// ----------------------------------------------------------------------------
// This View handles the Template Component
// ----------------------------------------------------------------------------
ImageClickRed = new Class(
{
   Extends : DialogView,
	
	// ************************************************************************
	// ************************************************************************
	//     MEMBERS VARIABLES
	// ************************************************************************
	// ************************************************************************	

	_dialogElement : null,
	_imageElement : null,

	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('ImageClickRed', this);
	},

	// ------------------------------------------------------------------------
	// After LoadComponentCommand instantiates the component, then this function
	// is called to pass the arguments and actually create the DOM objects.
	//
	// Arguments: 
	//     theBasePath (String) - Contains the component base path
	//     theDialogData (Object) - Contains argument data for the dialog
	// ------------------------------------------------------------------------
	init : function(theBasePath, theDialogData)
    {		
		this.parent(theDialogData,
		{
			basePath : theBasePath,
			title:  '',
			width:  773,
			height: 645,
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});
	},

	// ------------------------------------------------------------------------
	// Put any code which needs to be executed when the dialog is closed here
	// ------------------------------------------------------------------------
	_onClose : function()
	{
		this.parent();
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{		
		this.parent();

		this._dialogElement = this._widgetRootElement.getElement('#ImageClickRed_DialogContent');		
		
		this._imageElement = this._widgetRootElement.getElement('#ImageClickRed_Image');
		this._setImage(this._imageElement, this._data.find('img').text());
		this._imageElement.addEvent('load', this._onImageContentLoaded.bind(this));
		
		var this_url =this._data.find('url').text();
		if (this_url !== '') {
			this._imageElement.addEvent('click', this._onClick.bind(this));
			this._imageElement.mooTouchAdd({'click':true});
			this._imageElement.setStyle('cursor', 'pointer');
		}
	},
	
	_onImageContentLoaded : function()
	{
		// vertically center image
		var theContainerSize = this._dialogElement.measure(function(){return this.getSize();});
		var theImageSize = this._imageElement.measure(function(){return this.getSize();});
		var theCenteredTop = (theContainerSize.y - theImageSize.y) / 2;
//		this._dialogElement.setStyle('padding-top', theCenteredTop);
		
		this._show();
	},
	
	// ------------------------------------------------------------------------
	// Event handler for the click event on the image link
	// ------------------------------------------------------------------------
    _onClick : function()
    {
		var theUrl = this._data.find('url').text();
		Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl, source:'ImageClickRed'});
    },


	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});

