// ----------------------------------------------------------------------------
// This View handles the SampleDetail Dialog
// ----------------------------------------------------------------------------
LawsonDetail = new Class(
{
	Extends : DialogView,

	// ************************************************************************
	// ************************************************************************
	//     MEMBER VARIABLES
	// ************************************************************************
	// ************************************************************************

	// ********** Add variables for each data field here **********
	_itemInfoArray : [],
	
	// ------------------------------------------------------------------------
	// These functions return true if the <DynamicComponentName>-core.txt or 
	// <DynamicComponentName>-lang.txt files are present.
	// ------------------------------------------------------------------------
	hasSkinCoreAsset : function(){return true;},
	// If hasSkinLangAsset is true then _onChangeLanguage() is called when user changes languages (after language resources are loaded)
	hasSkinLangAsset : function(){return false;},
	
	// ------------------------------------------------------------------------
	// These functions return the list of plug-in assets to dynamically load for this component
	// ------------------------------------------------------------------------
	listJavascriptAssets : function(){return [];},
	listCssAssets : function(){return [];},

	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('LawsonDetail', this);
	},

	// ------------------------------------------------------------------------
	// After LoadComponentCommand instantiates the component, then this function
	// is called to pass the arguments and actually create the DOM objects.
	//
	// Arguments: 
	//     theBasePath (String) - Contains the component base path
	//     theDialogData (Object) - Contains argument data for the dialog
	// ------------------------------------------------------------------------
	init : function(theBasePath, theDialogData)
    {

			if (Browser.Platform.mobile)
			{
				var item1 = theDialogData.find('item')[0];
				var theUrl1 = item1.children[6].innerHTML;
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'LawsonDetail'});
				return;
			}

			if (window.cordova)
			{
				var item1 = theDialogData.find('item')[0];
				var theUrl1 = item1.children[6].innerHTML;
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'LawsonDetail'});
				return;
			}

			if (Browser.Platform.tablet7)
			{
				var item1 = theDialogData.find('item')[0];
				var theUrl1 = item1.children[6].innerHTML;
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'LawsonDetail'});
				return;
			}

		this.parent(theDialogData,
		{
			basePath : theBasePath,
			title:  '',				// Need to set this in onContentLoaded so it will pick up translated title from the component skin
			width:  968,
			height: 500,
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{
		this.parent();

        var items = this._data.find('item');
        items.each(function (index, value)
		{
           	var title = jQuery(value).find('title').text();
			var subtitle = jQuery(value).find('subtitle').text();
			var price = jQuery(value).find('price').text();
            var skulabel = jQuery(value).find('skulabel').text();
			var sku = jQuery(value).find('sku').text();
			var desclabel = jQuery(value).find('desclabel').text();
            var desc = jQuery(value).find('desc').text();
			var button1label = jQuery(value).find('button1label').text();
			var button1 = '<span class="LawsonDetail_icon glyphicon glyphicon-shopping-cart">&nbsp;</span>'+ button1label;
			var button1link = jQuery(value).find('button1').text();
			var button2label = jQuery(value).find('button2label').text();
			var button2 = '<span class="LawsonDetail_icon glyphicon glyphicon-th-list">&nbsp;</span>'+ button2label;
			var button2link = jQuery(value).find('button2').text();
			var videobuttonlabel = jQuery(value).find('videobuttonlabel').text();
			var video = jQuery(value).find('video').text();
			var imgpath = 'data/lfs14flx/011/html/';
			
			var tmpInfo = title + '|' + subtitle + '|' + price + '|' + skulabel + '|' + sku + '|' + desclabel + '|' + desc + '|' + button1label + '|' + button1 + '|' + button1link + '|' + button2label + '|' + button2 + '|' + button2link + '|' + videobuttonlabel + '|' + video

			var this_images = jQuery(value).find('images').find('img');

			if (this_images.length) 
			{
				for (var i = 0; i < this_images.length; i++)
				{
					var img_src = this_images[i].childNodes[0].nodeValue;
					tmpInfo += '|' + img_src;
				}
			}
			this._itemInfoArray.push(tmpInfo);
		}.bind(this));
		
		var itemsText = "";
		//var skipflag = false;
		for (var j=0; j < this._itemInfoArray.length; j++)
		{
			var tmpValues = this._itemInfoArray[j].split('|');
			var title = tmpValues[0];
			var subtitle = tmpValues[1];
			var price = tmpValues[2];
			var skulabel = tmpValues[3];
			var sku = tmpValues[4];
			var desclabel = tmpValues[5];
			var desc = tmpValues[6];
			var button1label = tmpValues[7];
			var button1 = tmpValues[8];
			var button1link = tmpValues[9];
			var button2label = tmpValues[10];
			var button2 = tmpValues[11];
			var button2link = tmpValues[12];
			var videobuttonlabel = tmpValues[13];
			var video = tmpValues[14];
			var images = tmpValues[15];
			var thumb1 = tmpValues[16];
			var thumb2 = tmpValues[17];
			var thumb3 = tmpValues[18];
			var imgpath = 'data/lfs14flx/011/html/';
			
			if (images == undefined)
				images = 'images/blank.jpg';

			if (this._itemInfoArray.length < 2)
			{
				this._leftPanel = this._widgetRootElement.getElement('#LawsonDetail_leftCarousel_cont');
				this._rightInfo = this._widgetRootElement.getElement('#LawsonDetail_rightProductInfo');
				this._bottomInfo = this._widgetRootElement.getElement('#LawsonDetail_bottomProductInfo');
				this._leftPanel.hide();
				this._rightInfo.removeClass('col-sm-7');
				this._rightInfo.addClass('col-sm-0');
				this._bottomInfo.removeClass('col-sm-7');
				this._bottomInfo.addClass('col-sm-12');
				this._bottomInfo.setStyle('margin', '0px');
			}
			
			this._arrowup = this._widgetRootElement.getElement('.glyphicon-chevron-up');
			this._arrowdown = this._widgetRootElement.getElement('.glyphicon-chevron-down');
			if (this._itemInfoArray.length <= 3)
			{
				this._arrowup.hide();
				this._arrowdown.hide();
			}

			if (j%3==0)
			{
				if (j==0)
				{
			this._title = this._widgetRootElement.getElement('#LawsonDetail_ProductTitle h4');
			if (title == undefined)
				this._title.dispose();
			else
				this._title.set('text', title);

			this._subtitle = this._widgetRootElement.getElement('#LawsonDetail_ProductSubtitle h5');
			if (subtitle == undefined)
				this._subtitle.dispose();
			else
				this._subtitle.set('text', subtitle);

			this._sku = this._widgetRootElement.getElement('#LawsonDetail_ProductSKU p');
			if (sku == undefined)
				this._sku.dispose();
			else
				this._sku.set('text', skulabel+' '+sku);

			this._imageMain = this._widgetRootElement.getElement('.LawsonDetail_mainImage');
			this._leftPanel = this._widgetRootElement.getElement('#LawsonDetail_leftCarousel_cont');
			this._rightInfo = this._widgetRootElement.getElement('#LawsonDetail_rightProductInfo');
			this._bottomInfo = this._widgetRootElement.getElement('#LawsonDetail_bottomProductInfo');
			if (images == undefined)
			{
//				this._imageMain.hide();
				this._imageMain.set('src', 'data/lfs14flx/011/html/images/blank.jpg');
//				this._leftPanel.hide();
//				this._rightInfo.removeClass('col-sm-7');
//				this._rightInfo.addClass('col-sm-0');
//				this._bottomInfo.removeClass('col-sm-7');
//				this._bottomInfo.addClass('col-sm-12');
//				this._bottomInfo.setStyle('margin', '0px');
			}
			else
			{
				this._imageMain.show();
				this._imageMain.set('src', imgpath+images);
			}
			this._thumb1 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage1');
			if (thumb1 == undefined)
				this._thumb1.dispose();
			else
			{
				this._thumb1.set('src', imgpath+thumb1);
				this._thumb1.addEvent('click', this._onClickThumb1.bind(this));
			}

			this._thumb2 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage2');
			if (thumb2 == undefined)
				this._thumb2.dispose();
			else
			{
				this._thumb2.set('src', imgpath+thumb2);
				this._thumb2.addEvent('click', this._onClickThumb2.bind(this));
			}

			this._thumb3 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage3');
			if (thumb3 == undefined)
				this._thumb3.dispose();
			else
			{
				this._thumb3.set('src', imgpath+thumb3);
				this._thumb3.addEvent('click', this._onClickThumb3.bind(this));
			}

			this._button1 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton1');
			this._button1.set('href', button1link);
			this._button1.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-shopping-cart">&nbsp;</span>' + button1label);
			if ((button1link == undefined) || (button1link == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton1').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton1').setStyle('display', 'inline-block');

			this._button2 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton2');
			this._button2.set('href', button2link);
			this._button2.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-th-list">&nbsp;</span>' + button2label);
			if ((button2link == undefined) || (button2link == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton2').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton2').setStyle('display', 'inline-block');

			this._button3 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton3');
			this._button3.set('href', video);
			this._button3.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-facetime-video">&nbsp;</span>' + videobuttonlabel);
			if ((video == undefined) || (video == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton3').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton3').setStyle('display', 'inline-block');
			
			this._descLabel = this._widgetRootElement.getElement('#LawsonDetail_ProductDescriptionLabel h4');
			if ((desclabel == undefined) || (desclabel == ''))
				this._descLabel.dispose();
			else
				this._descLabel.set('text', desclabel);

			this._desc = this._widgetRootElement.getElement('#LawsonDetail_ProductDescription');
			if ((desc == undefined) || (desc == ''))
				this._desc.dispose();
			else
				this._desc.set('html', desc);
					
					itemsText += '<div class=\"item active\">';
					
				}
				else
					itemsText += '<div class=\"item\">';

				itemsText += '<div class=\"row\">';
			}

			itemsText += '<div class=\"side-item col-sm-12\" id=\"array_'+j+'\">';
			itemsText += '<div class=\"col-item\">';
			itemsText += '<div class=\"photo col-sm-5\" id=\"array_'+j+'\">';
			itemsText += '<img class=\"img-responsive\" src=\"' + imgpath + images + '\" alt=\"a\" />';
			itemsText += '</div>';
			itemsText += '<div class=\"info col-sm-7\">';
			itemsText += '<div class=\"row\">';
			itemsText += '<div class=\"price col-md-12\">';
			itemsText += '<h5 class=\"title bold\" id=\"array_'+j+'\">' + title + '</h5>';
			itemsText += '<h5 class=\"sku\" id=\"array_'+j+'\">' + skulabel + ' ' + sku + '</h5>';
			itemsText += '</div>';
			itemsText += '</div>';
			itemsText += '<div class=\"clearfix\"></div>';
			itemsText += '</div>';
			itemsText += '</div>';
			itemsText += '</div>';
			
			// Each third item needs close as well as last item
			if (((j+1)%3 == 0) || (j == this._itemInfoArray.length-1))
			{
				itemsText += '</div>';
				itemsText += '</div>';
			}
		}

		var sliderElement = this._widgetRootElement.getElement('.carousel-inner');
		sliderElement.set('html', itemsText);
		
		var photo_els = this._widgetRootElement.getElements('.side-item');
	
		photo_els.each(function(item, index)
		{
			item.addEvent('click', this._onSetActiveItem.bind(this));
			item.mooTouchAdd({'click':true});
		}.bind(this));
		this._show();
	},

	// ************************************************************************
	// ************************************************************************
	//
	// ********** Add Custom Functions and Event Handlers here **********
	//
	// ************************************************************************
	// ************************************************************************
			
	// ------------------------------------------------------------------------
	// Button click event handlers
	// ------------------------------------------------------------------------
	_onSetActiveItem : function(e)
	{
			var j = e.target.getParent().get('id');
			if (j == null)
				var j = e.target.get('id');
			var npos = j.indexOf('_');
			j = j.substr(npos+1);
			
			var tmpValues = this._itemInfoArray[j].split('|');
			var title = tmpValues[0];
			var subtitle = tmpValues[1];
			var price = tmpValues[2];
			var skulabel = tmpValues[3];
			var sku = tmpValues[4];
			var desclabel = tmpValues[5];
			var desc = tmpValues[6];
			var button1label = tmpValues[7];
			var button1 = tmpValues[8];
			var button1link = tmpValues[9];
			var button2label = tmpValues[10];
			var button2 = tmpValues[11];
			var button2link = tmpValues[12];
			var videobuttonlabel = tmpValues[13];
			var video = tmpValues[14];
			var images = tmpValues[15];
			var thumb1 = tmpValues[16];
			var thumb2 = tmpValues[17];
			var thumb3 = tmpValues[18];
			var imgpath = 'data/lfs14flx/011/html/';
			
			if (images == undefined)
				images = 'images/blank.jpg';

			this._title = this._widgetRootElement.getElement('#LawsonDetail_ProductTitle h4');
			if (title == undefined)
				this._title.dispose();
			else
				this._title.set('text', title);

			this._subtitle = this._widgetRootElement.getElement('#LawsonDetail_ProductSubtitle h5');
			if (subtitle == undefined)
				this._subtitle.dispose();
			else
				this._subtitle.set('text', subtitle);

			this._sku = this._widgetRootElement.getElement('#LawsonDetail_ProductSKU p');
			if (sku == undefined)
				this._sku.dispose();
			else
				this._sku.set('text', skulabel+' '+sku);

			this._imageMain = this._widgetRootElement.getElement('.LawsonDetail_mainImage');
			this._leftPanel = this._widgetRootElement.getElement('#LawsonDetail_leftCarousel_cont');
			this._rightInfo = this._widgetRootElement.getElement('#LawsonDetail_rightProductInfo');
			this._bottomInfo = this._widgetRootElement.getElement('#LawsonDetail_bottomProductInfo');
			if (images == undefined)
			{
				this._imageMain.hide();
				this._imageMain.set('src', 'data/lfs14flx/011/html/images/blank.jpg');
//				this._leftPanel.hide();
//				this._rightInfo.removeClass('col-sm-7');
//				this._rightInfo.addClass('col-sm-0');
//				this._bottomInfo.removeClass('col-sm-7');
//				this._bottomInfo.addClass('col-sm-12');
//				this._bottomInfo.setStyle('margin', '0px');
			}
			else
			{
				this._imageMain.show();
				this._imageMain.set('src', imgpath+images);
			}

			this._thumb1 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage1');
			if (thumb1 == undefined)
			{}
			else if (thumb1 == '')
				this._thumb1.dispose();
			else
			{
				this._thumb1.removeEvents('click', this._onClickThumb1.bind(this));
				this._thumb1.set('src', imgpath+thumb1);
				this._thumb1.addEvent('click', this._onClickThumb1.bind(this));
			}

			this._thumb2 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage2');
			if (thumb2 == undefined)
			{}
			else if (thumb2 == '')
				this._thumb2.dispose();
			else
			{
				this._thumb2.removeEvents('click', this._onClickThumb2.bind(this));
				this._thumb2.set('src', imgpath+thumb2);
				this._thumb2.addEvent('click', this._onClickThumb2.bind(this));
			}

			this._thumb3 = this._widgetRootElement.getElement('.LawsonDetail_thumbImage3');
			if (thumb3 == undefined)
			{}
			else if (thumb3 == '')
				this._thumb3.dispose();
			else
			{
				this._thumb3.removeEvents('click', this._onClickThumb3.bind(this));
				this._thumb3.set('src', imgpath+thumb3);
				this._thumb3.addEvent('click', this._onClickThumb3.bind(this));
			}

			this._button1 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton1');
			this._button1.set('href', button1link);
			this._button1.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-shopping-cart">&nbsp;</span>' + button1label);
			if ((button1link == undefined) || (button1link == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton1').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton1').setStyle('display', 'inline-block');

			this._button2 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton2');
			this._button2.set('href', button2link);
			this._button2.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-th-list">&nbsp;</span>' + button2label);
			if ((button2link == undefined) || (button2link == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton2').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton2').setStyle('display', 'inline-block');

			this._button3 = this._widgetRootElement.getElement('#LawsonDetail_ProductButton3');
			this._button3.set('href', video);
			this._button3.set('html', '<span class="LawsonDetail_icon glyphicon glyphicon-facetime-video">&nbsp;</span>' + videobuttonlabel);
			if ((video == undefined) || (video == ''))
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton3').setStyle('display', 'none');
			else
					this._widgetRootElement.getElement('#LawsonDetail_ProductButton3').setStyle('display', 'inline-block');
				
			this._descLabel = this._widgetRootElement.getElement('#LawsonDetail_ProductDescriptionLabel h4');
			if (desclabel == '')
			{}
			else
				this._descLabel.set('text', desclabel);

			this._desc = this._widgetRootElement.getElement('#LawsonDetail_ProductDescription');
			if (desc == '')
			{}
			else if (desc == undefined)
				this._desc.dispose();
			else
				this._desc.set('html', desc);		
	},

	_onClickThumb1 : function(e)
	{
		var img_src = e.target.attributes.src.value;
		var main_img_src = this._imageMain.src;
		this._imageMain.set('src', imgpath+img_src);
		this._thumb1.set('src', imgpath+main_img_src);
	},

	_onClickThumb2 : function(e)
	{
		var img_src = e.target.attributes.src.value;
		var main_img_src = this._imageMain.src;
		this._imageMain.set('src', imgpath+img_src);
		this._thumb2.set('src', imgpath+main_img_src);
	},

	_onClickThumb3 : function(e)
	{
		var img_src = e.target.attributes.src.value;
		var main_img_src = this._imageMain.src;
		this._imageMain.set('src', imgpath+img_src);
		this._thumb3.set('src', imgpath+main_img_src);
	},

	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});
