// ----------------------------------------------------------------------------
// This View handles NOWDetail Dialog
// ----------------------------------------------------------------------------
NOWDetail = new Class(
{
    Extends : DialogView,

	// ************************************************************************
	// ************************************************************************
	//     MEMBER VARIABLES
	// ************************************************************************
	// ************************************************************************
	
	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('NOWDetail', this);
	},

	// ------------------------------------------------------------------------
	// After LoadComponentCommand instantiates the component, then this function
	// is called to pass the arguments and actually create the DOM objects.
	//
	// Arguments: 
	//     theBasePath (String) - Contains the component base path
	//     theDialogData (Object) - Contains argument data for the dialog
	// ------------------------------------------------------------------------
	init : function(theBasePath, theWidgetData)
    {	
		var check_mobile = Skin.getInstance().get("ArchivesMobile");
		if (check_mobile == 'no')
		{
			if (Browser.Platform.mobile) // || Browser.ie to have IE behave the same as mobile
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}

		var check_cordova = Skin.getInstance().get("ArchivesCordova");
		if (check_cordova == 'no')
		{
			if (window.cordova)
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}
		
		var check_facebook = Skin.getInstance().get("ArchivesFacebook");
		if (check_facebook == 'no')
		{
			if (this._appState.get(fromCommandLineArg) == 'Facebook')
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}
		
		var check_ie = Skin.getInstance().get("ArchivesIE");
		if (check_ie == 'no')
		{
			if (Browser.IE)
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}
		
		var check_tablet7 = Skin.getInstance().get("ArchivesTablet7");
		if (check_tablet7 == 'no')
		{
			if (Browser.Platform.tablet7)
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}
		
		var check_tablet = Skin.getInstance().get("ArchivesTablet");
		if (check_tablet == 'no')
		{
			if (Browser.Platform.tablet)
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}
		
		var check_desktop = Skin.getInstance().get("ArchivesDesktop");
		if (check_desktop == 'no')
		{
			if (Browser.Platform.desktop)
			{
				var theUrl1 = Skin.getInstance().get("ArchivesLink");
				Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theUrl1, source:'NOWDetail'});
				return;
			}
		}

		var theWidgetOptions = new Object(
		{
			basePath : theBasePath,
			title: Skin.getInstance().get('ProductName', '')+' Archives',
			width:  Skin.getInstance().getNumber('ArchivesWidth', 800),
			height: Skin.getInstance().getNumber('ArchivesHeight', 600),
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});
		this.parent(theWidgetData, theWidgetOptions);
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{
		this.parent();
		
		this._iFrame = this._widgetRootElement.getElement('.NOWDetail_IFrame');
		this._iFrame.setStyles({'width':this.options.width, 'height':this.options.height});

		var archives_link = Skin.getInstance().get("ArchivesLink");
		if (this.archives_link != 'undefined')
			var theUrl = Skin.getInstance().get("ArchivesLink");
		else
			var theUrl = this._data.Url;
		
		// Is it an absolute path?
		if (theUrl.substr(0,4).toLowerCase() == 'http')
			this._iFrame.src = theUrl;
		else
			this._iFrame.src = this._data.BasePath + theUrl;
		
		this._show();
	},

	// ************************************************************************
	// ************************************************************************
	//
	// ************* Add Custom Functions and Event Handlers here *************
	//
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// Event handler for the click event on the image link
	// ------------------------------------------------------------------------

	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});