<%
'-----------------------------------------------------------------------
'ASP State management - using client cookies rather than session variables
'                       Do not use special characters in name or key
'                       string arguments for cross compatibility between
'						server-side ASP and client-side Javascript 
'						(use only a-zA-Z0-9)
'-----------------------------------------------------------------------

Class c2kCookie

	Private m_name
	Private m_days

	Public Sub init(name, days)
		m_name = name
		m_days = days
	End Sub

	Public Sub setValue(key, value)
		Response.Cookies(m_name)(key) = value
		If (Not IsNull(m_days)) Then
			Response.Cookies(m_name).Expires = Now() + m_days
		End If
	End Sub

	Public Function getValue(key)
		getValue = Request.Cookies(m_name)(key)
	End Function
		
End Class

Dim c2kSession, c2kPersist

' allocate object for handling session cookies
Set c2kSession = New c2kCookie
c2kSession.init strvarCookieName&"xS1",null

' allocate object for handling persistent cookies
Set c2kPersist = new c2kCookie
c2kPersist.init strvarCookieName&"xP1", 365

'--------------------
' Example usage
'Dim str
'c2kSession.setValue "QQQ","Randy"
'str = c2kSession.getValue("QQQ")
'--------------------

%>


<script language=javascript type=text/javascript>

// -----------------------------------------------------------------------
// Javascript State management - sharing same client cookies as ASP
//                      Do not use special characters in name or key
//                      string arguments for cross compatibility between
//						server-side ASP and client-side Javascript 
//						(use only a-zA-Z0-9)
// -----------------------------------------------------------------------

function c2kCookie(name, days)
{
	var m_name = name;
	var m_days = days;

	var m_args = "";

	if (m_days)
	{   	
		var expire = new Date();
		expire.setTime(expire.getTime() + m_days*24*60*60*1000);
		m_args += "; expires=" + expire.toUTCString() ;
  	}
		  
	this.getCookie = function()
	{
		var theMatch;

		// This checks if the first cookie is the one we want
		theMatch = document.cookie.match(new RegExp("(^" + m_name + "=)([^;]*)(;|$)"));
		if (theMatch)
			return theMatch[2];

		// This checks if the cookie is somewhere further into the cookie string
		theMatch = document.cookie.match(new RegExp("(; " + m_name + "=)([^;]*)(;|$)"));

		return theMatch ? theMatch[2] :null;
	}  
	    
	this.setValue = function(key, value)
	{
		var theCookie, newCookie;

		// The ASP side expects escape rather than encodeURI
		//value = window.encodeURI ? encodeURI(value) : escape(value);
		value = escape(value);

		theCookie = this.getCookie();
		if (theCookie)
			theCookie = "&" + theCookie;
		newCookie = null;

		if (value)
		{
			if (!theCookie)
			{
				newCookie = "&" + key + "=" + value;
			}
			else
			{
				if (new RegExp("&" + key + "=").test(theCookie))
					newCookie = theCookie.replace(new RegExp("&" + key + "=([^&;]*)"), "&"+key+"="+value);
				else
					newCookie = theCookie + "&"+key+"="+value;
			}
		}
		else if (new RegExp("&" + key + "=").test(theCookie) )
		{
			newCookie = theCookie.replace(new RegExp("&" + key + "=([^&;]*)"), "");
		}
	
		if (newCookie)
		{
			newCookie = m_name + "=" + newCookie.substr(1);
			document.cookie = newCookie + m_args;
		}			
	}
	  
	this.getValue = function(key)
	{
		var theCookie, theMatch, theValue;

		theCookie = this.getCookie();
		if (theCookie)
		{
			theCookie = "&" + theCookie;
			theMatch = theCookie.match(new RegExp("&" + key + "=([^&;]*)"));
	
			if (theMatch)
			{
				theValue = theMatch[1];

				if (theValue)
				{ 
					// The ASP side performed escape rather than encodeURI
					//return window.decodeURI ? decodeURI(theValue) : unescape(theValue);
					return unescape(theValue);
				}
			}
		}
		return "";
	}
}

// allocate object for handling session cookies
var c2kSession = new c2kCookie("<%=strVarCookieName%>"+"xS1");

// allocate object for handling persistent cookies
var c2kPersist = new c2kCookie("<%=strVarCookieName%>"+"xP1",365);

// --------------------
// Example usage
// c2kSession.setValue("KEY","Gibbs");
// alert(c2kSession.getValue("KEY"));
// --------------------

</script>

