// ----------------------------------------------------------------------------
// This View handles the Obsolete Cart
// ----------------------------------------------------------------------------
NordsonBasicCart = new Class(
{
	Extends : DialogView,

	// ************************************************************************
	// ************************************************************************
	//     MEMBERS VARIABLES
	// ************************************************************************
	// ************************************************************************	
	
	_appState : null,
	_items : new Array(),
	_itemAdded : null,
	
	_itemNameArray : null,
	_productIdArray : null,

	// ********** Add variables for each data field here **********
	
	_emailPanel : null,
	_emailPanelToName : null,
	_emailPanelToEmail : null,
	_emailPanelToCompanyName : null,
	_emailPanelToZip : null,
	_emailPanelNotes : null,

	_sentPanel : null,
	_listPanel : null,
	_addPanel : null,
	_orderPanel : null,
	
	_buttonContainer : null,
	_buttonActionCenter : null,
	
	_emptyMessage: null,
	_emailBtn : null,
	_printBtn : null,
	_orderBtn : null,
	_morderBtn : null,
	_backBtn : null,
	_back_sentBtn : null,
	_back_orderBtn : null,
	_sendBtn : null,
	_msendBtn : null,
	_send_orderBtn : null,
	_addBtn : null,
	_cancelBtn : null,
	_continueBtn : null,
	_clearallBtn : null,
	_editBtn : null,
	_doneBtn : null,
	_placeBtn : null,
	
	_shipMatchesBillingYRdoBtn : null,
	_shipMatchesBillingNRdoBtn : null,

	_cancel_container : null,
	_add_container : null,
	_length_warning : null,
	_continue_container : null,
	_emailOrder_container : null,
	_send_container : null,
	_sendorder_container : null,
	_place_container : null,

	_incButton : null,
	_decButton : null,

	_mooTouchScroller : null,

	_applicationViewElement : null,
	_book : null,
	
	_dialogWidth : null,
	_dialogHeight : null,

	_fields : null,


	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('NordsonBasicCart', this);
	},

    init : function(theBasePath, theDialogData)
    {		

		//View Port Globals
		var viewportWidth = jQuery(window).width();
		var viewportHeight = jQuery(window).height();

		this._applicationViewElement = $('ApplicationView');
		var appSize = this._applicationViewElement.measure(function(){return this.getSize();});
		var appWidth = appSize.x;
		var appHeight = appSize.y;
		
		this._fields = 3;

		var portraitWidth, portraitHeight, landscapeWidth, landscapeHeight;
		if (DeviceMgr.getInstance().isOrientationPortrait())
		{
			portraitWidth = DeviceMgr.getInstance().getOrientationScreenWidth()*window.devicePixelRatio;
			portraitHeight = DeviceMgr.getInstance().getOrientationScreenHeight()*window.devicePixelRatio;
		}
		else
		{
			portraitWidth = DeviceMgr.getInstance().getOrientationScreenHeight()*window.devicePixelRatio;
			portraitHeight = DeviceMgr.getInstance().getOrientationScreenWidth()*window.devicePixelRatio;
		}
		landscapeWidth = portraitHeight;
		landscapeHeight = portraitWidth;

		if (theDialogData)
		{
			// Add to Cart dialog size
			portraitWidth = 320;
			portraitHeight = 200;
			landscapeWidth = 320;
			landscapeHeight = 200;
		}
		else if (Browser.Platform.desktop)
		{
			// Cart dialog size for desktop
			portraitWidth = 960;
			portraitHeight = appHeight - 37
			landscapeWidth = portraitWidth;
			landscapeHeight = portraitHeight;
		}
		else
		{
			// Cart dialog size for tablet and mobile forced to full screen
			portraitWidth = 9999;
			portraitHeight = 9999;
			landscapeWidth = 9999;
			landscapeHeight = 9999;		
		}
		
		this.parent(theDialogData,
		{
			basePath:           theBasePath,
			title:  			'',			// Need to set this in onContentLoaded so it will pick up translated title from the component skin
			portraitWidth:		portraitWidth,
			portraitHeight:     portraitHeight,
			landscapeWidth:		landscapeWidth,
			landscapeHeight:	landscapeHeight,
			isDraggable:		false,
			hasFooter:          false,
			isModal: 			true,
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});	
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{	
		this.parent();		
		this._popUpWindow.setTitle(Skin.getInstance().get('CartDialogTitle', 'Quote Request'));

		this._emailPanel = this._widgetRootElement.getElement('#NordsonBasicCart_EmailPanel');
		this._sentPanel = this._widgetRootElement.getElement('#NordsonBasicCart_SentPanel');
		this._listPanel = this._widgetRootElement.getElement('#NordsonBasicCart_ListPanel');
		this._orderPanel = this._widgetRootElement.getElement('#NordsonBasicCart_OrderPanel');
		this._addPanel = this._widgetRootElement.getElement('#NordsonBasicCart_AddPanel');
		this._buttonContainer = this._widgetRootElement.getElement('#NordsonBasicCart_button_container');
		this._buttonActionCenter = this._widgetRootElement.getElement('#NordsonBasicCart_button_container .actionCenter');

		this._emptyMessage = this._widgetRootElement.getElement('#NordsonBasicCart_ListPanel_Empty');
		this._emailBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_email');
		this._memailBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_memail');
		this._printBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_print');		
		this._orderBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_order');
		this._morderBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_morder');
		this._backBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_back');
		this._back_sentBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_back_sent');
		this._back_orderBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_back_order');
		this._sendBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_send');
		this._msendBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_msend');
		this._send_orderBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_sendorder');
		this._placeBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_place');
		this._addBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_add');
		this._cancelBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_cancel');
		this._continueBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_continue');
		this._clearallBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_clearall');
		this._mclearallBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_mclearall');
		this._editBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_edit');
		this._doneBtn = this._widgetRootElement.getElement('#NordsonBasicCart_button_done');
		this._shipMatchesBillingYRdoBtn = this._widgetRootElement.getElement('#shipmatchesbill1');
		this._shipMatchesBillingNRdoBtn = this._widgetRootElement.getElement('#shipmatchesbill2');

		this._cancel_container = this._widgetRootElement.getElement('#NordsonBasicCart_cancel_container');
		this._add_container = this._widgetRootElement.getElement('#NordsonBasicCart_add_container');
		this._length_warning = this._widgetRootElement.getElement('#NordsonBasicCart_length_warning');
		this._continue_container = this._widgetRootElement.getElement('#NordsonBasicCart_continue_container');
		this._emailOrder_container = this._widgetRootElement.getElement('#NordsonBasicCart_emailOrder_container');
		this._send_container = this._widgetRootElement.getElement('#NordsonBasicCart_send_container');
		this._sendorder_container = this._widgetRootElement.getElement('#NordsonBasicCart_sendorder_container');
		this._place_container = this._widgetRootElement.getElement('#NordsonBasicCart_place_container');

		this._incButton = this._widgetRootElement.getElement('#NordsonBasicCart_increment');
		this._decButton = this._widgetRootElement.getElement('#NordsonBasicCart_decrement');
		
		
		this._widgetRootElement.getElement('#NordsonBasicCart_button_email').set('html', Skin.getInstance().get('Cart_Email', 'Email'));
		this._widgetRootElement.getElement('#NordsonBasicCart_button_order').set('html', Skin.getInstance().get('Cart_Checkout', 'Request Quote'));
		this._widgetRootElement.getElement('#NordsonBasicCart_button_morder').set('html', Skin.getInstance().get('Cart_Checkout', 'Request Quote'));
		this._widgetRootElement.getElement('#NordsonBasicCart_button_continue').set('html', Skin.getInstance().get('Cart_Continue', 'Continue Shopping'));
		this._widgetRootElement.getElement('#NordsonBasicCart_button_send').set('html', Skin.getInstance().get('Cart_Send', 'Send'));	
		this._widgetRootElement.getElement('#NordsonBasicCart_button_sendorder').set('html', Skin.getInstance().get('Cart_SubmitOrder', 'Submit'));
		this._widgetRootElement.getElement('.NordsonBasicCart_button_back_text').set('html', Skin.getInstance().get('Cart_Back', 'Back'));		
		this._widgetRootElement.getElement('.NordsonBasicCart_button_back_order_text').set('html', Skin.getInstance().get('Cart_BackOrder', 'Back'));
		this._widgetRootElement.getElement('#NordsonBasicCart_button_clearall').set('html', Skin.getInstance().get('Cart_ClearAll', 'Clear'));
		
		// ********** Add event handlers (don't forget mooTouchAdd) **********
		this._emailBtn.addEvent('click', this._onClickEmail.bind(this));
		this._memailBtn.addEvent('click', this._onClickEmail.bind(this));
		this._printBtn.addEvent('click', this._onClickPrint.bind(this));		
		this._orderBtn.addEvent('click', this._onClickOrder.bind(this));
		this._morderBtn.addEvent('click', this._onClickOrder.bind(this));
		this._backBtn.addEvent('click', this._onClickBack.bind(this));
		this._back_sentBtn.addEvent('click', this._onClickBack.bind(this));
		this._back_orderBtn.addEvent('click', this._onClickBack.bind(this));
		this._sendBtn.addEvent('click', this._onClickSend.bind(this));
		this._msendBtn.addEvent('click', this._onClickSend.bind(this));
		this._send_orderBtn.addEvent('click', this._onClickSendOrder.bind(this));
		this._addBtn.addEvent('click', this._onClickAdd.bind(this));
		this._cancelBtn.addEvent('click', this._onCancel.bind(this));
		this._continueBtn.addEvent('click', this._onContinue.bind(this));
		this._clearallBtn.addEvent('click', this._onClearAll.bind(this));
		this._mclearallBtn.addEvent('click', this._onClearAll.bind(this));
		this._shipMatchesBillingYRdoBtn.addEvent('click', this._onShipMatchesBilling.bind(this));
		this._shipMatchesBillingNRdoBtn.addEvent('click', this._onShipDoesntMatchBilling.bind(this));

		this._emailBtn.mooTouchAdd({'click':true});
		this._memailBtn.mooTouchAdd({'click':true});
		this._printBtn.mooTouchAdd({'click':true});
		this._orderBtn.mooTouchAdd({'click':true});
		this._morderBtn.mooTouchAdd({'click':true});
		this._placeBtn.mooTouchAdd({'click':true});
		this._backBtn.mooTouchAdd({'click':true});
		this._back_sentBtn.mooTouchAdd({'click':true});
		this._back_orderBtn.mooTouchAdd({'click':true});
		this._sendBtn.mooTouchAdd({'click':true});
		this._msendBtn.mooTouchAdd({'click':true});
		this._send_orderBtn.mooTouchAdd({'click':true});
		this._addBtn.mooTouchAdd({'click':true});
		this._cancelBtn.mooTouchAdd({'click':true});
		this._continueBtn.mooTouchAdd({'click':true});
		this._clearallBtn.mooTouchAdd({'click':true});
		this._mclearallBtn.mooTouchAdd({'click':true});
		this._editBtn.mooTouchAdd({'click':true});
		this._doneBtn.mooTouchAdd({'click':true});
		this._shipMatchesBillingYRdoBtn.mooTouchAdd({'click':true});
		this._shipMatchesBillingNRdoBtn.mooTouchAdd({'click':true});

		this._incButton.mooTouchAdd({'click':true});
		this._decButton.mooTouchAdd({'click':true});
		this._setStyleForLangResource(this._printBtn,   'background-image', 'NordsonBasicCartPrintBtnPath');
		this._setStyleForLangResource(this._placeBtn,   'background-image', 'NordsonBasicCartPlaceBtnPath');
		this._setStyleForLangResource(this._back_sentBtn,    'background-image', 'NordsonBasicCartBackBtnPath');
		this._setStyleForLangResource(this._addBtn,     'background-image', 'NordsonBasicCartAddBtnPath');
		this._setStyleForLangResource(this._cancelBtn,  'background-image', 'NordsonBasicCartCancelBtnPath');
		this._setStyleForLangResource(this._clearallBtn,'background-image', 'NordsonBasicCartClearAllBtnPath');
		this._setStyleForLangResource(this._mclearallBtn,'background-image', 'NordsonBasicCartClearAllBtnPath');
		this._setStyleForLangResource(this._editBtn,    'background-image', 'NordsonBasicCartEditBtnPath');
		this._setStyleForLangResource(this._doneBtn,    'background-image', 'NordsonBasicCartDoneBtnPath');

		this._items = Preferences.getInstance().get('Cart');
		if (this._items === undefined)
			this._items = [];

		if (this._data)
		{
			this._widgetRootElement.getElement('#NordsonBasicCart_description').set('html', this._data.find('description').text());
			this.width = 300;
			this._onAddList();
		}
		else
		{
			this._updateCount();
			this._onClickList();
		}

		this._buttonContainer.show();

		this._show();
		// Dialog had to be visible before we arrange footer dialog buttons
		this._NordsonBasicCart_Behaviors();
		this._doButtonContainerLayout();
	},

	// ------------------------------------------------------------------------
	// Put any code which needs to be executed when the dialog is closed here
	// ------------------------------------------------------------------------
	onClose : function()
	{
		Facade.getInstance().removeMediator(this.mediatorName);
		this._popUpWindow.onClose();
		(function()
		{
			// This cancel is necessary to avoid an error in IE8
			this._popUpWindow.getWindowDiv().get('tween').cancel();
			this._widgetRootElement.destroy();
		}).delay(250, this);

		Preferences.getInstance().flush();
		this.parent();
	},
	
	_onCancel : function()
	{
		this._popUpWindow.close();
	},

	_onContinue : function()
	{
		this._popUpWindow.close();
	},
	
	// ************************************************************************
	// ************************************************************************
	//
	// ************* Add Custom Functions and Event Handlers here *************
	//
	// ************************************************************************
	// ************************************************************************
	_remItem : function(e)
	{
		var theItem = e.target;
		var theButtonId = theItem.get('id');
		var theItemId = theButtonId.substr(theButtonId.lastIndexOf('_')+1);
		var theLineId = 'NordsonBasicCart_ListPanel_itemwrapper_'+theItemId;
		this._listElement = $(theLineId);
		var theItemWrapper = this._listElement.getElementById(theButtonId);
		theItemWrapper.destroy();
		this._items.splice(theItemId, 1);
		this._updateCount();
		this._displayItems();
		this._keepEditState();
		if (this._items.length == 0)
		{ 
			this._orderBtn.hide();
			this._morderBtn.hide();
		}		
	},
	
	_onPageClick : function(event)
	{
		
		event.preventDefault();
		var theItemLink = event.target.get('href');

		this._popUpWindow.close();

		Facade.getInstance().sendNotification(ApplicationFacade.GOTO_URL, {link:theItemLink});
	},

	_onClickAdd : function(e)
	{
		if (!this._data)
			return;
			
		this._emailElement = this._widgetRootElement.getElement('#NordsonBasicCart_fields');
		var element = this._emailElement.getElementById('NordsonBasicCart_quantity');
		var qty = element.value;



		var theBook = this._appState.get(currentBook);
		var theBookList = this._appState.get(currentBookList);
		var theBookIndex = theBookList.getBookListIndex(theBook.bookCode);
		var theBookListEntry = theBookList.getBookListEntry(theBookIndex);
		var theBookPageIndex = this._appState.get(currentBookPageDest).BookPageIndex;
		var theBookTitle =  theBookListEntry.title;
		var theBookCover = theBookListEntry.thumbnailBig;
		var theBookCoverUrl = theBookListEntry.getBookFolder(false) + theBookListEntry.thumbnailBig;
		var oem, sku, description, bookcode, pagelabel, booktitle;


		this._itemAdded = oem = this._data.find('oem').text();
		sku = this._data.find('sku').text();
		description = this._data.find('description').text();
		bookcode = theBook.bookCode;
		booktitle = theBookTitle;
		bookcover = theBookCoverUrl;
		pagelabel = theBook.getPageLabel(theBookPageIndex);

		var notInList = true;
		for (var i = 0; i < this._items.length; i++)
		{
				if ( (this._items[i].sku == sku) && (this._items[i].description == description) && (this._items[i].oem == oem) )
					notInList = false;
		}
		if (notInList)
		{
			this._items.push({sku:sku, description:description, oem:oem, qty:qty, bookcode:bookcode, booktitle:booktitle, bookcover:bookcover, pagelabel:pagelabel});
			Preferences.getInstance().set('Cart', this._items);
			this._updateCount();
		}

		this._cancel_container.show();
		this._add_container.show();
		this._length_warning.hide();
		this._continue_container.hide();
		this._emailOrder_container.hide();
		this._send_container.hide();
		this._sendorder_container.hide();
		this._place_container.hide();

		this._emailBtn.hide();
		this._memailBtn.hide();
		this._printBtn.hide();
		this._orderBtn.hide();
		this._morderBtn.hide();
		this._placeBtn.hide();

		this._popUpWindow.close();
	},
	
	_changeQty : function(e)
	{
		var theItem = e.target;
		var theButtonId = theItem.get('id');
		var theItemId = theButtonId.substr(theButtonId.lastIndexOf('_')+1);
		var theLineId = 'NordsonBasicCart_ListPanel_itemwrapper_'+theItemId;
		this._listElement = $(theLineId);
		var theItemWrapper = this._listElement.getElementById(theButtonId);
		var newQty = theItemWrapper.value;
		this._items[theItemId].qty = newQty;
	},
	
	_changeUL : function(e)
	{
		var theItem = e.target;
		var theButtonId = theItem.get('id');
		var theItemId = theButtonId.substr(theButtonId.lastIndexOf('_')+1);
		var theLineId = 'NordsonBasicCart_ListPanel_itemwrapper_'+theItemId;
		this._listElement = $(theLineId);
		var theItemWrapper = this._listElement.getElementById(theButtonId);
		var newQty = theItemWrapper.value;
	},	
	
	_updateCount : function()
	{
		var cnt = 0;
		this._items.each(function(item, index)
		{
			cnt += Number(item.qty);
		});
		this._appState.set(cartListCnt, cnt);
		
		this._items.sort(this._sortByDescription);
		
		Preferences.getInstance().flush(); // rems and adds weren't getting updated if user left dialog without closing it
		
		this._placeBtn.hide();
		
		// Hide/show/the empty cart image
		if (this._items.length == 0)
		{
			this._listPanel.addClass('NordsonBasicCart_EmptyCart');
			this._emailBtn.hide();
			this._memailBtn.hide();
			this._printBtn.hide();
			this._orderBtn.hide();
			this._morderBtn.hide();
			this._clearallBtn.hide();
			this._mclearallBtn.hide();
			this._editBtn.hide();
			this._doneBtn.hide();
			this._emptyMessage.show();

		}
		else
		{
			this._listPanel.removeClass('NordsonBasicCart_EmptyCart');
			this._emailBtn.show();
			this._memailBtn.show();
			this._printBtn.hide();
			this._clearallBtn.show();
			this._mclearallBtn.show();
			this._editBtn.show();
			this._emptyMessage.hide();
		}
		this._doButtonContainerLayout();
	},
	
	// ------------------------------------------------------------------------
	// This is an array sort helper function which will sort an array of records
	// in ascending order by description name
	// ------------------------------------------------------------------------
	_sortByDescription : function(a, b)
	{
		if (a.description == b.description) return 0;
		if (a.description > b.description) return 1;
		return -1;
	},
	
	_displayItems : function()
	{
		var itemsText = '';
		
		this._items.sort(this._sortByDescription);

		var cart_currency = Skin.getInstance().get('CartCurrency', '$');
		
		for (var i = 0; i < this._items.length; i++)
		{
			itemsText += '<div id=\"NordsonBasicCart_ListPanel_itemwrapper_'+i+'\" class=\"NordsonBasicCart_ListPanel_item row\">';
			
			itemsText += '	<div class=\"NordsonBasicCart_ListPanel_crosslinkcolumn three columns\">';
			itemsText += '		<div id=\"NordsonBasicCart_ListPanel_'+i+'_wrapper\" class=\"NordsonBasicCart_ListPanel_cover_wrapper four columns\">'
			itemsText += '		<img class=\"NordsonBasicCart_ListPanel_cover\" src=\"'+this._items[i].bookcover+'\" />';
			itemsText += '		<a id=\"NordsonBasicCart_ListPanel_coverLink_'+i+'\" class="NordsonBasicCart_ListPanel_coverLink" href=\"app:BookCode='+this._items[i].bookcode+'&PageLabel='+this._items[i].pagelabel+'\"></a>';
			itemsText += '		</div>'
			itemsText += '		<a id=\"NordsonBasicCart_ListPanel_booktitle_'+i+'\" class=\"NordsonBasicCart_ListPanel_booktitle eight columns\" href=\"app:BookCode='+this._items[i].bookcode+'&PageLabel='+this._items[i].pagelabel+'\"">'+this._items[i].booktitle+'</a>';
			itemsText += '		<div id=\"NordsonBasicCart_ListPanel_page_'+i+'_wrapper\" class=\"NordsonBasicCart_ListPanel_page_wrapper eight columns\">';
			itemsText += '			<a id=\"NordsonBasicCart_ListPanel_page_'+i+'\" class=\"NordsonBasicCart_ListPanel_page mobilehide\" href=\"app:BookCode='+this._items[i].bookcode+'&PageLabel='+this._items[i].pagelabel+'\">Page: '+this._items[i].pagelabel+'</a>';
			itemsText += '		</div>';
			itemsText += '	</div>'

			itemsText += '	<div class=\"NordsonBasicCart_ListPanel_detailscolumn five columns\">';
			itemsText += '		<div class=\"NordsonBasicCart_ListPanel_description twelve columns\">'+this._items[i].description+'</div>';
			itemsText += '		<div class=\"NordsonBasicCart_ListPanel_sku twelve columns\">SKU: '+this._items[i].sku+'</div>';
			itemsText += '			<a id=\"NordsonBasicCart_ListPanel_page_'+i+'\" class=\"NordsonBasicCart_ListPanel_page mobileshow\" href=\"app:BookCode='+this._items[i].bookcode+'&PageLabel='+this._items[i].pagelabel+'\">Page: '+this._items[i].pagelabel+'</a>';			
			itemsText += '	</div>';
			
			itemsText += '	<div class=\"two columns\">';
			itemsText += '		<div id=\"NordsonBasicCart_ListPanel_qtyLabel\" class=\"four columns\">Qty</div><input type=\"text\" value=\"'+this._items[i].qty+'\" id=\"NordsonBasicCart_ListPanel_qty_'+i+'\" name=\"qty\" onclick=\"this.focus();this.select()\" class=\"NordsonBasicCart_ListPanel_qty five columns form-control\"/>';			
			itemsText += '	</div>';

			itemsText += '	<div class=\"NordsonBasicCart_ListPanel_delete one columns\">';
			itemsText += '		<div id="cart_item_'+i+'" class=\"NordsonBasicCart_ListPanel_remove glyphicon glyphicon-ban-circle glyph-primary\"></div>';
			itemsText += '	</div>';
			itemsText += '</div>';
			

		}
		this._listElement = this._widgetRootElement.getElement('#NordsonBasicCart_ListPanel_theList');
	    this._listElement.set('html', itemsText);
	    this._doFormSelect(this._listElement);
		var theElementList;

		//Loop through remove events
		theElementList = this._listElement.getElements('.NordsonBasicCart_ListPanel_remove');
		theElementList.each(function(item, index)
		{
			item.addEvent('click', this._remItem.bind(this));
			item.mooTouchAdd({'click':true});
		}.bind(this));

		//Loop through page link events
		theElementList = this._listElement.getElements('.NordsonBasicCart_ListPanel_coverLink, .NordsonBasicCart_ListPanel_page, .NordsonBasicCart_ListPanel_booktitle');
		theElementList.each(function(item, index)
		{
			item.addEvent('click', this._onPageClick.bind(this));
			item.mooTouchAdd({'click':true});
		}.bind(this));

		//Loop through quantity events
		theElementList = this._listElement.getElements('.NordsonBasicCart_ListPanel_qty');
		theElementList.each(function(item, index)
		{
			item.addEvent('change', this._changeQty.bind(this));
			item.mooTouchAdd({'click':true});
		}.bind(this));

		this._listPanel.show();
		var scrollHeight = 0;
		if ((this._itemAdded != "") && (this._itemAdded != null))
		{
			for (var i = 0; i < this._items.length; i++)
			{
				if (this._itemAdded == this._items[i].recipe)
				{
					//this._mooTouchScroller.scrollTo(0,scrollHeight);
					this._itemAdded = "";
				}
				scrollHeight += this._listElement.getElementById('NordsonBasicCart_ListPanel_itemwrapper_'+i).offsetHeight;
			}
		}
				jQuery('.NordsonBasicCart_ListPanel_qty').on('keypress', function(ev) 
				{
					var keyCode = window.event ? ev.keyCode : ev.which;
					//codes for 0-9
					if (keyCode < 48 || keyCode > 57) 
					{
					//codes for backspace, delete, enter
						if (keyCode != 0 && keyCode != 8 && keyCode != 13 && !ev.ctrlKey) 
						{
							ev.preventDefault();
						}
					}
				});
	},
	
	// ------------------------------------------------------------------------
	// Button click event handlers
	// ------------------------------------------------------------------------
	
	_onClickList : function(e)
	{
		this._cancel_container.hide();
		this._add_container.hide();
		this._continue_container.show();
		this._emailOrder_container.hide();
		this._send_container.hide();
		this._sendorder_container.hide();
		this._place_container.hide();

		this._addBtn.hide();
		this._placeBtn.hide();
		this._cancelBtn.hide();
		this._backBtn.hide();
		this._back_sentBtn.hide();
		this._back_orderBtn.hide();
		this._sendBtn.hide();
		this._msendBtn.hide();
		this._send_orderBtn.hide();
		this._buttonContainer.removeClass('NordsonBasicCart_AddDialog');
		if (this._items.length == 0)
		{

			this._cancel_container.hide();
			this._add_container.hide();
			this._continue_container.show();
			this._emailOrder_container.hide();
			this._send_container.hide();
			this._sendorder_container.hide();

			this._emailBtn.hide();
			this._memailBtn.hide();
			this._printBtn.hide();
			this._orderBtn.hide();
			this._morderBtn.hide();
			this._clearallBtn.hide();
			this._mclearallBtn.hide();
			this._editBtn.hide();
			this._doneBtn.hide();
			this._continueBtn.show();
			this._emptyMessage.show();	
		}	
		else
		{
			this._cancel_container.hide();
			this._add_container.hide();
			this._continue_container.show();
			this._emailOrder_container.show();
			this._send_container.hide();
			this._sendorder_container.hide();

			this._emailBtn.show();
			this._memailBtn.show();
			this._printBtn.hide();
			this._orderBtn.show();
			this._morderBtn.show();
			this._clearallBtn.show();
			this._mclearallBtn.show();
			this._editBtn.show();
			this._emptyMessage.hide();			
		}	
		if (this._items.length == 0)
		{
			this._emailOrder_container.show();
			this._orderBtn.hide();
			this._morderBtn.hide();
		}
		else
		{
			this._emailOrder_container.show();
			this._orderBtn.show();
			this._morderBtn.show();
		}
		this._doButtonContainerLayout();
		this._displayItems();
		this._sentPanel.hide();
		this._emailPanel.hide();
		this._addPanel.hide();
		this._orderPanel.hide();
		this._listPanel.show();
	},

	_onAddList : function(e)
	{
		
		this._cancel_container.show();
		this._add_container.show();
		this._continue_container.hide();
		this._emailOrder_container.hide();
		this._send_container.hide();
		this._sendorder_container.hide();

		this._backBtn.hide();
		this._back_sentBtn.hide();
		this._back_orderBtn.hide();
		this._sendBtn.hide();
		this._msendBtn.hide();
		this._send_orderBtn.hide();
		this._emailBtn.hide();
		this._memailBtn.hide();
		this._printBtn.hide();
		this._orderBtn.hide();
		this._morderBtn.hide();
		this._continueBtn.hide();
		
		this._addBtn.show();
		this._cancelBtn.show();
		this._buttonContainer.addClass('NordsonBasicCart_AddDialog');
	
		this._sentPanel.hide();
		this._emailPanel.hide();
		this._orderPanel.hide();
		this._listPanel.hide();
		this._addPanel.show();

	},

	_onClickEmail : function(e)
	{
		this._cancel_container.hide();
		this._add_container.hide();
		this._continue_container.show();
		this._emailOrder_container.hide();
		this._sendorder_container.hide();
		this._send_container.show();

		this._addBtn.hide();
		this._cancelBtn.hide();
		this._continueBtn.hide();
	
		this._emailBtn.hide();
		this._memailBtn.hide();
		this._printBtn.hide();
		this._orderBtn.hide();
		this._morderBtn.hide();
		this._continueBtn.show();
		this._backBtn.show();
		this._back_sentBtn.hide();
		this._back_orderBtn.hide();
		this._send_orderBtn.hide();
		this._sendBtn.show();
		this._msendBtn.show();
		this._doButtonContainerLayout();

		this._sentPanel.hide();
		this._orderPanel.hide();
		this._listPanel.hide();
		this._addPanel.hide();
		this._emailPanel.show();
	},
	
	_onClickSend : function(e)
	{
		this._emailElement = this._widgetRootElement.getElement('#NordsonBasicCart_EmailPanel');
		var theLanguageList, theLanguageIndex, theLanguageCode;
		theLanguageList = this._appState.get(currentLanguageList);
		theLanguageIndex = this._appState.get(currentLanguageIndex);
		theLanguageCode = theLanguageList.getLanguageCode(theLanguageIndex);
		/*var fields = 0;
		for (var key in this._items[0])
		{
			if (this._items[0].hasOwnProperty(key))
				fields++;
		}
		var length = (this._items.length*fields);*/
		var length = (this._items.length*this._fields);
/*		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_FromNameField');
		var fromName = element.value;
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_FromEmailField');
		var fromEmail = element.value;
*/		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_ToNameField');
		var toName = element.value;
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_ToEmailField');
		var toEmail = element.value;
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_CompanyName');
		var toCompanyName = element.value;
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_Zip');
		var toZip = element.value;		
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailPanel_NotesField');
		var notes = escape(element.value);
		var element = this._emailElement.getElementById('NordsonBasicCart_EmailCheckBox');
		var echeckbox = escape(element.checked);		

		//validate form input
		toEmail = toEmail.trim();
//		if (!FieldValidation.getInstance().isEmailValid(toEmail, 'Recipients Email'))
//			return;
/*		fromEmail = fromEmail.trim();
		if (!FieldValidation.getInstance().isEmailValid(fromEmail, 'Your Email'))
			return;
*/		
//		if (!FieldValidation.getInstance().isNameValid(toName, 'Recipients Name'))
//			return;	
			
/*		if (!FieldValidation.getInstance().isNameValid(fromName, 'Your Name'))
			return;		
*/
		this._cancel_container.hide();
		this._add_container.hide();
		this._continue_container.show();
		this._emailOrder_container.hide();
		this._send_container.hide();
		this._sendorder_container.hide();

		this._addBtn.hide();
		this._cancelBtn.hide();
		this._emailBtn.hide();
		this._memailBtn.hide();
		this._printBtn.hide();
		this._orderBtn.hide();
		this._morderBtn.hide();
		this._backBtn.hide();
		this._back_sentBtn.show();
		this._back_orderBtn.hide();
		this._sendBtn.hide();
		this._msendBtn.hide();
		this._send_orderBtn.hide();
		this._doButtonContainerLayout();
		
		var data1 = '';
		for (var i = 0; i < this._items.length; i++)
		{
			data1 += escape(this._items[i].sku)+'**'+escape(this._items[i].description)+'**'+escape(this._items[i].qty)+'**';
		}
	
		var cart_currency = Skin.getInstance().get('CartCurrency', '$');
		var postBody = 'lang='+theLanguageCode+'&length='+length+'&ds='+cart_currency+'&toName='+escape(toName)+'&toEmail='+toEmail+'&toCompanyName='+escape(toCompanyName)+'&toZip='+escape(toZip)+'&echeckbox='+escape(echeckbox)+'&notes='+notes+'&data1='+escape(data1);
		var pathToCode = this._getBasePath();
		var isPhoneGap = (window.cordova) ? true : false;
		var theServicePath = REMOTE_PATH_TO_SERVICES;
		if (isPhoneGap)
			pathToCode = theServicePath + pathToCode;
		var myHTMLRequest = new Request.HTML({url: pathToCode + 'ServiceEmailList.php'+CacheMgr.getInstance().getResourceCacheArg('RelId','?')}).post(postBody);

		this._widgetRootElement.getElement('#NordsonBasicCart_SentPanel_ToName').set('html', toName);
		this._widgetRootElement.getElement('#NordsonBasicCart_SentPanel_ToEmail').set('html', toEmail);
//		this._widgetRootElement.getElement('#NordsonBasicCart_SentPanel_ToCompanyName').set('html', toCompanyName);
//		this._widgetRootElement.getElement('#NordsonBasicCart_SentPanel_ToZip').set('html', toZip);

		if(jQuery('#NordsonBasicCart_EmailCheckBox').is(':checked'))
		{
			this._widgetRootElement.getElement('#NordsonBasicCart_ThanksMsg').set('html', 'Your Quote Request has been sent to Nordson for quoting. A Nordson representative will contact you soon with your quote.');
		}
		else
		{
			this._widgetRootElement.getElement('#NordsonBasicCart_ThanksMsg').set('html', 'Thank you for using the Nordson Quote Request. You should receive an email shortly.');
		}
		
		var dialogName = this.componentName;
		dialogName = dialogName.replace('DialogView', '');
		Facade.getInstance().sendNotification(ApplicationFacade.LOG_EVENT, {category:dialogName, action:'Emailed'});

		this._orderPanel.hide();
		this._listPanel.hide();
		this._emailPanel.hide();
		this._addPanel.hide();
		this._sentPanel.show();
		this._backBtn.show();
	},
	
	_validateEmail : function(addy, title)
	{
		var atpos=addy.indexOf("@");
		var dotpos=addy.lastIndexOf(".");
		if (atpos<1 || dotpos<atpos+2 || dotpos+2>=addy.length)
		{
			Facade.getInstance().sendNotification(ApplicationFacade.ALERT_OK, {message:Skin.getInstance().get('ShareEmailInvalidEmail', 'Not a valid e-mail address'), title:title});
			return false;
		}
		return true;
	},
	
	_validateName : function(name, title)
	{
		if (name.length < 1)
		{
			Facade.getInstance().sendNotification(ApplicationFacade.ALERT_OK, {message:Skin.getInstance().get('ShareEmailInvalidName', 'Please enter a valid name'), title:title});
			return false;
		}
		return true;
	},
	
	_validateRequired : function(string, title)
	{
		title = unescape(title);
		if (string.length < 1)
		{
			Facade.getInstance().sendNotification(ApplicationFacade.ALERT_OK, {message:Skin.getInstance().get('FillInRequiredFields', 'Please fill in all required fields'), title:title});
			return false;
		}
		return true;
	},
	
	_validateDropdown : function(string, title)
	{
		if (string == 'default')
		{
			Facade.getInstance().sendNotification(ApplicationFacade.ALERT_OK, {message:Skin.getInstance().get('MakeDropdownSelection', 'Please select an option from the drop down'), title:title});
			return false;
		}
		return true;
	},
	
	_onClickOrder : function(e)
	{
		this._cancel_container.hide();
		this._add_container.hide();
		this._continue_container.show();
		this._emailOrder_container.hide();
		this._send_container.hide();
		this._sendorder_container.show();

		this._addBtn.hide();
		this._cancelBtn.hide();
		this._continueBtn.hide();
		
		this._buttonContainer.show();
		this._emailBtn.hide();
		this._memailBtn.hide();
		this._printBtn.hide();
		this._orderBtn.hide();
		this._morderBtn.hide();
		this._continueBtn.show();
		this._backBtn.hide();
		this._back_sentBtn.hide();
		this._back_orderBtn.show();
		this._sendBtn.hide();
		this._msendBtn.hide();
		this._send_orderBtn.show();
		this._doButtonContainerLayout();

		this._sentPanel.hide();
		this._listPanel.hide();
		this._addPanel.hide();
		this._emailPanel.hide();
		this._orderPanel.show();
	},
	
	_onClickSendOrder : function(e)
	{
		var params = {};
		
		var data1 = '';
		for (var i = 0; i < this._items.length; i++)
		{
			data1 += escape(this._items[i].sku)+'**'+escape(this._items[i].description)+'**'+escape(this._items[i].qty)+'**';
		}
		
		var cart_currency = Skin.getInstance().get('CartCurrency', '$');
		var theLanguageList, theLanguageIndex, theLanguageCode;
		theLanguageList = this._appState.get(currentLanguageList);
		theLanguageIndex = this._appState.get(currentLanguageIndex);
		theLanguageCode = theLanguageList.getLanguageCode(theLanguageIndex);

		var length = (this._items.length*this._fields);
		var theCompanyCode = Skin.getInstance().get("DefaultCompanyCode");
		var theBook = this._appState.get(currentBook);
		var theBookCode = theBook.bookCode;
		
		params['data1'] = data1;
		params['lang'] = theLanguageCode;
		params['length'] = length;
		params['fields'] = this._fields;
		params['currency'] = cart_currency;
		params['CompanyCode'] = theCompanyCode;
		params['BookCode'] = theBookCode;
	
		this._orderPanelElement = this._widgetRootElement.getElement('#NordsonBasicCart_OrderPanel');
		var inputValid = true;

		var element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingCompanyField');
		var bCompany = element.value;
		inputValid = this._validateRequired(bCompany, 'Company');
		if (!inputValid)
			return;
		params['CompanyName'] = bCompany;
		
		var element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingContactField');
		var bName = element.value;
		inputValid = this._validateRequired(bName, 'Contact');
		if (!inputValid)
			return;
		params['Contact'] = bName;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingPhoneNumberField');
		var bPhone = element.value;
		inputValid = this._validateRequired(bPhone, 'Phone Number');
		if (!inputValid)
			return;
		params['PhoneNumber'] = bPhone;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingEmailAddressField');
		var bEmail = element.value;
		inputValid = this._validateRequired(bEmail, 'Email Address');
		if (!inputValid)
			return;
		params['EmailAddress'] = bEmail;
			
		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingEmailAddressField');
		var bEmail2 = element.value;
		inputValid = this._validateRequired(bEmail2, 'Email Address');
		if (!inputValid)
			return;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingProjectField');
		var bProject = element.value;
		params['ProjectName'] = bProject;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingAddressField');
		var bAddress = element.value;
		inputValid = this._validateRequired(bAddress, 'Address');
		if (!inputValid)
			return;
		params['Address'] = bAddress;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingCityField');
		var bCity = element.value;
		inputValid = this._validateRequired(bCity, 'City');
		if (!inputValid)
			return;
		params['City'] = bCity;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingStateField');
		var bState = element.value;
		inputValid = this._validateRequired(bState, 'State');
		if (!inputValid)
			return;
		params['State'] = bState;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingZipCodeField');
		var bZip = element.value;
		inputValid = this._validateRequired(bZip, 'Zip Code');
		if (!inputValid)
			return;
		params['ZipCode'] = bZip;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_BillingCountryField');
		var bCountry = element.value;
		inputValid = this._validateRequired(bCountry, 'Country');
		if (!inputValid)
			return;
		params['Country'] = bCountry;

		element = this._orderPanelElement.getElementById('referenceSourceDropdown');
		var bTimeFrame = element.value;
		inputValid = this._validateRequired(bTimeFrame, 'TimeFrame');
		if (!inputValid)
			return;
		params['TimeFrame'] = bTimeFrame;

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ApplicationInfo');
		var bAppInfo = element.value;
		//inputValid = this._validateRequired(bAppInfo, 'AppInfo');
		//if (!inputValid)
		//	return;
		params['AppInfo'] = bAppInfo;
			
		if (bEmail != bEmail2)
		{
			Facade.getInstance().sendNotification(ApplicationFacade.ALERT_OK, {message:"Email address doesn't match confirm email address field.", title:title});
			return;
		}
		
		element = this._orderPanelElement.getElementById('referenceSourceDropdown');
		var bSource = element.value;
		params['referenceSource'] = bSource;
		
		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_PromoCodeField');
		var bPromoCode = element.value;
		params['PromoCode'] = bPromoCode;
		
		element = this._orderPanelElement.getElementById('shippingMethodDropdown');
		var bShippingOptions = element.value;
		params['shippingMethod'] = bShippingOptions;

		if (this._orderPanelElement.getElementById('backorder1').checked==true)
			params['backorder'] = 'Yes';
		else
			params['backorder'] = 'No';
			
		if (this._orderPanelElement.getElementById('newcatalog1').checked==true)
			params['newcatalog'] = 'Yes';
		else
			params['newcatalog'] = 'No';

		var theBookPageIndex = this._appState.get(currentBookPageDest).BookPageIndex;
		var secidx = theBook.getSectionIndex(theBookPageIndex);
		theBookPageIndex = theBookPageIndex.toInt();
		
		// Empty the cart items from the dialog
		this._onClearAll();
		var pathToCode = this._getBasePath();
		var isPhoneGap = (window.cordova) ? true : false;
		var theServicePath = REMOTE_PATH_TO_SERVICES;
		if (isPhoneGap)
			pathToCode = theServicePath + pathToCode;		
		
		
		var aspfile = (RELATIVE_PATH_TO_CODE.indexOf('-bin')>-1) ? '' : 'debug.php';
		theUrlStr = REMOTE_PATH_TO_SERVICES + aspfile+'?BookCode='+theBookCode+'&Sgt='+secidx+'&PageLabel='+theBook.getPageLabel(theBookPageIndex);
		theImageUrlStr = this._getBasePath();
		if (isPhoneGap)
			theImageUrlStr = pathToCode;
				
		params['return_url'] = theUrlStr;
		params['image_url'] = theImageUrlStr;

		var postBody = '';
		for(var key in params) {
			if(params.hasOwnProperty(key)) 
			{
				postBody += '&' + key + '=' + params[key];
			 }
		}

		var theServicePath = this._getBasePath();
		if (window.cordova)
			theServicePath = REMOTE_PATH_TO_SERVICES + this._getBasePath();
		var myHTMLRequest = new Request.HTML({url: theServicePath + 'ServiceCheckOut.php'+CacheMgr.getInstance().getResourceCacheArg('RelId','?')}).post(postBody);
		Facade.getInstance().sendNotification(ApplicationFacade.LOG_EVENT, {category:this.componentName.replace('DialogView',''), action:'Checkout'});

		this._orderPanel.hide();
		this._listPanel.hide();

		this._send_orderBtn.hide();

		this._widgetRootElement.getElement('#NordsonBasicCart_ThanksMsg').set('html', 'Your Quote Request has been sent to Nordson for quoting. A Nordson representative will contact you soon with your quote.');

		this._sentPanel.show();
	},
	
	_post_to_url : function(path, params, method) 
	{
	    method = method || "post"; // Set method to post by default, if not specified.

	    // The rest of this code assumes you are not using a library.
	    // It can be made less wordy if you use one.
	    var form = document.createElement("form");
	    form.setAttribute("method", method);
	    form.setAttribute("action", path);

	    for(var key in params) {
	        if(params.hasOwnProperty(key)) {
	            var hiddenField = document.createElement("input");
	            hiddenField.setAttribute("type", "hidden");
	            hiddenField.setAttribute("name", key);
	            hiddenField.setAttribute("value", params[key]);

	            form.appendChild(hiddenField);
	         }
	    }

	    document.body.appendChild(form);
	    form.submit();
	},
	
	_onShipMatchesBilling : function(e)
	{
		this._orderPanelElement = this._widgetRootElement.getElement('#NordsonBasicCart_OrderPanel');
		var element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingNameField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingAddressField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingCityField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingStateField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingZipCodeField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingPhoneField');
		element.disabled = true;
		element.value = 'Using Billing Information';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingCountryField');
		element.disabled = true;
		element.value = 'Using Billing Information';
	},
	
	_onShipDoesntMatchBilling : function(e)
	{
		this._orderPanelElement = this._widgetRootElement.getElement('#NordsonBasicCart_OrderPanel');
		var element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingNameField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingAddressField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingCityField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingStateField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingZipCodeField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingPhoneField');
		element.disabled = false;
		element.value = '';

		element = this._orderPanelElement.getElementById('NordsonBasicCart_OrderPanel_ShippingCountryField');
		element.disabled = false;
		element.value = '';
	},

	_onClearAll : function(e)
	{
		this._items = [];
		Preferences.getInstance().set('Cart', this._items);
		this._updateCount();
		this._displayItems();
	},
	
	_onClickBack : function(e)
	{
		this._cancel_container.hide();
		this._add_container.hide();
		this._continue_container.show();
		this._emailOrder_container.show();
		this._send_container.hide();
		this._sendorder_container.hide();
		this._place_container.hide();

		this._addBtn.hide();
		this._cancelBtn.hide();

		if (Browser.Platform.mobile)
			this._buttonContainer.hide();

		this._sendBtn.hide();
		this._msendBtn.hide();
		this._send_orderBtn.hide();
		this._orderBtn.show();
		this._morderBtn.show();
		this._backBtn.hide();
		this._back_sentBtn.hide();
		this._back_orderBtn.hide();
		this._emailBtn.show();
		this._memailBtn.show();
		this._printBtn.hide();
		this._doButtonContainerLayout();

		this._emailPanel.hide();
		this._sentPanel.hide();
		this._addPanel.hide();
		this._orderPanel.hide();
		this._listPanel.show();		
	},
	
	_onClickPrint : function(e)
	{  
		var windowContent = '<!DOCTYPE html>';
		windowContent += '<html>'
		windowContent += '<head><title>Nordson</title>';
		windowContent += '<link type=\"text/css\" rel=\"stylesheet\" href=\"' + this._getBasePath() + this.componentName + '.css\" />';
		windowContent += '</head>';
		windowContent += '<body><div id=\"NordsonBasicCart_ListPanel\">';
		for (var i = 0; i < this._items.length; i++)
		{
			windowContent += '<div id=\"NordsonBasicCart_ListPanel_itemwrapper_'+i+'\" class=\"NordsonBasicCart_ListPanel_item\">';
			windowContent += '<div class=\"NordsonBasicCart_ListPanel_description\">Description: '+this._items[i].description+'</div>';
			windowContent += '<div class=\"NordsonBasicCart_ListPanel_sku\">Part Number: '+this._items[i].sku+'</div>';
			windowContent += '<div class=\"NordsonBasicCart_ListPanel_qty_'+i+'\">Quantity: '+this._items[i].qty+'</div>';
			windowContent += '<br>';
			
			windowContent += '</div>';
		}
		windowContent += '</div></body>';
		windowContent += '</html>';
		
		Facade.getInstance().sendNotification(ApplicationFacade.PRINT_TEXT, {content:windowContent});
		var dialogName = this.componentName;
		dialogName = dialogName.replace('DialogView', '');
		Facade.getInstance().sendNotification(ApplicationFacade.LOG_EVENT, {category:dialogName, action:'Printed'});
		this._popUpWindow.close();	
	},	
		
	_doButtonContainerLayout : function()
	{
		// Set the container left to zero before measuring to make sure buttons will all fit side by side without wrapping
		this._buttonActionCenter.setStyle('left',0);
		var theParentSize = this._buttonContainer.measure(function(){return this.getSize();});
		var theSize = this._buttonActionCenter.measure(function(){return this.getSize();});
		this._buttonActionCenter.setStyle('left',(theParentSize.x/2) - (theSize.x/2));
	},

	_keepEditState : function()
	{
		jQuery(function() {
		    jQuery('.NordsonBasicCart_ListPanel_remove').show();
		    jQuery('#NordsonBasicCart_button_edit').hide();
		    jQuery(".NordsonBasicCart_ListPanel_qty").removeAttr("disabled");
		});		
	},

	_NordsonBasicCart_Behaviors : function()
	{

		jQuery("#NordsonBasicCart_increment").click(function() {
		    var curValue = jQuery('#NordsonBasicCart_quantity').val();
		    var curNumber = parseFloat(curValue);

			jQuery('#NordsonBasicCart_quantity').val(curNumber + 1);
		});

		jQuery("#NordsonBasicCart_decrement").click(function() {
		    var curValue = jQuery('#NordsonBasicCart_quantity').val();
		    var curNumber = parseFloat(curValue);
		    	if ( curNumber >= 2) {
					jQuery('#NordsonBasicCart_quantity').val(curNumber - 1);
				} else {}
		});
	},
	
	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});