// ----------------------------------------------------------------------------
// This View handles the HartfordDetail Dialog
// ----------------------------------------------------------------------------
ScotchliteDetail = new Class(
{
	Extends : DialogView,

	// ************************************************************************
	// ************************************************************************
	//     MEMBER VARIABLES
	// ************************************************************************
	// ************************************************************************

	// ********** Add variables for each data field here **********

	_titleElement : null,
	_descElement : null,
	_imageElement : null,
		
	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('ScotchliteDetail', this);
	},

	// ------------------------------------------------------------------------
	// After LoadComponentCommand instantiates the component, then this function
	// is called to pass the arguments and actually create the DOM objects.
	//
	// Arguments: 
	//     theBasePath (String) - Contains the component base path
	//     theDialogData (Object) - Contains argument data for the dialog
	// ------------------------------------------------------------------------
	init : function(theBasePath, theDialogData)
    {		
		this.parent(theDialogData,
		{
			basePath : theBasePath,
			title:  'United States',
			width:  1008,
			height: 798,
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{
		this.parent();

		this._widgetRootElement.getElement('#West').addEvent('click', this._onClickWest.bind(this));
		this._widgetRootElement.getElement('#West').mooTouchAdd({'click':true});

		this._widgetRootElement.getElement('#Southeast').addEvent('click', this._onClickSoutheast.bind(this));
		this._widgetRootElement.getElement('#Southeast').mooTouchAdd({'click':true});

		this._widgetRootElement.getElement('#East').addEvent('click', this._onClickEast.bind(this));
		this._widgetRootElement.getElement('#East').mooTouchAdd({'click':true});

		this._widgetRootElement.getElement('#Northeast').addEvent('click', this._onClickNortheast.bind(this));
		this._widgetRootElement.getElement('#Northeast').mooTouchAdd({'click':true});

		this._widgetRootElement.getElement('#Midwest').addEvent('click', this._onClickMidwest.bind(this));
		this._widgetRootElement.getElement('#Midwest').mooTouchAdd({'click':true});

		this._widgetRootElement.getElement('#Central').addEvent('click', this._onClickCentral.bind(this));
		this._widgetRootElement.getElement('#Central').mooTouchAdd({'click':true});

		this._show();
	},
	
	// ************************************************************************
	// ************************************************************************
	//
	// ************* Add Custom Functions and Event Handlers here *************
	//
	// ************************************************************************
	// ************************************************************************
	_onClickClose : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
	},
	_onClickWest : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_West').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_West').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_West').mooTouchAdd({'click':true});
	},
	_onClickSoutheast : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_Southeast').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_Southeast').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_Southeast').mooTouchAdd({'click':true});
	},
	_onClickEast : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_East').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_East').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_East').mooTouchAdd({'click':true});
	},
	_onClickNortheast : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_Northeast').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_Northeast').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_Northeast').mooTouchAdd({'click':true});
	},
	_onClickMidwest : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_Midwest').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_Midwest').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_Midwest').mooTouchAdd({'click':true});
	},
	_onClickCentral : function(e)
	{
		theProfiles = this._widgetRootElement.getElements('.ScotchliteDetail_Profile');
		theProfiles.each(function(item, index)
		{
			item.hide();
		});
		this._widgetRootElement.getElement('#ScotchliteDetail_Central').show();
		this._widgetRootElement.getElement('#ScotchliteDetail_Central').addEvent('click', this._onClickClose.bind(this));
		this._widgetRootElement.getElement('#ScotchliteDetail_Central').mooTouchAdd({'click':true});
	},

	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});
