// ----------------------------------------------------------------------------
// This View handles the Scene7Video Dialog
// ----------------------------------------------------------------------------
Scene7Video = new Class(
{
	Extends : DialogView,

	// ************************************************************************
	// ************************************************************************
	//     MEMBERS VARIABLES
	// ************************************************************************
	// ************************************************************************	

	// ********** Add variables for each data field here **********

	_video : null,
	videoUrl : null,

	// ************************************************************************
	// ************************************************************************
	//     LIST OF PLUGIN ASSETS TO LOAD DYNAMICALLY
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// This function returns the list of plug-ins to dynamically load for this component
	//
	// @return {String[]} - the array of plug-ins to load.
	// ------------------------------------------------------------------------
	listJavascriptAssets : function()
	{
		return	[];
	},
	
	listCssAssets : function()
	{
		return	[];
	},

	// ************************************************************************
	// ************************************************************************
	//     CONSTRUCTOR
	// ************************************************************************
	// ************************************************************************	

	initialize : function()
	{
		this.parent('Scene7Video', this);
	},

	// ------------------------------------------------------------------------
	// After LoadComponentCommand instantiates the component, then this function
	// is called to pass the arguments and actually create the DOM objects.
	//
	// Arguments: 
	//     theBasePath (String) - Contains the component base path
	//     theDialogData (Object) - Contains argument data for the dialog
	// ------------------------------------------------------------------------
	init : function(theBasePath, theDialogData)
    {		
		this.parent(theDialogData,
		{
			basePath : theBasePath,
			title:  '',				// Need to set this in onContentLoaded so it will pick up translated title from the component skin
			width:  660,
			height: 380,
			_ie_comma_safety : 0	// Keep as last option (doesn't have trailing comma)
		});
	},

	// ************************************************************************
	// ************************************************************************
	//     PROTECTED MEMBERS AND FUNCTIONS
	// ************************************************************************
	// ************************************************************************

	// ------------------------------------------------------------------------
	// The Dialog DOM content (if any) is loaded by the time this function is
	// called so here we create and add any extra UIComponents and attach
	// event listeners.
	// ------------------------------------------------------------------------
	_onContentLoaded : function()
	{		
		this.parent();
		this._popUpWindow.setTitle(Skin.getInstance().get('Scene7VideoDialogTitle', ''));
		
		// Test for JSON object
		if(typeof this._data.url != "undefined")
		{
			videoUrl = this._data.url;
		}
		else // must be XML
		{
			videoUrl = this._data.find('url').text();
		}
		this._video = this._widgetRootElement.getElement('#Scene7Video');
		this._video.set('src', videoUrl);
		this._show();
	},

	_ie_comma_safety : 0	// Keep as last member of class (doesn't have trailing comma)
});
